// @ts-ignore
import type { Config, Context } from 'https://edge.netlify.com';

const FILES = ['index', 'metadata', 'stories'];

export default async (
  request: Request,
  { next }: Context,
): Promise<Response> => {
  const response = (await next()) as Response;
  const origin = request.headers.get('Origin');

  if (origin) {
    response.headers.set('Access-Control-Allow-Origin', origin);
    response.headers.set('Access-Control-Allow-Credentials', 'true');
  }

  return response;
};

export const config: Config = {
  path: FILES.map((file) => `/${file}.json`),
};
