import { dirname, join } from 'path';
import { fileURLToPath } from 'url';
import { copy, ensureDir } from 'fs-extra/esm';

export const generateFunctions = async ({
  constants: { INTERNAL_EDGE_FUNCTIONS_SRC: dest },
  utils: { build },
}) => {
  try {
    const __dirname = dirname(fileURLToPath(import.meta.url));
    const src = join(__dirname, '..', '..', 'edge-functions');

    await ensureDir(dest);
    await copy(src, dest);
  } catch (error) {
    build.failPlugin('Failed to generate edge functions', {
      error,
    });
  }
};
